//----------------------------------------------------------------------------------
//		k΍@NbvtB^
//----------------------------------------------------------------------------------

#include <windows.h>
#include <math.h>
#include <float.h> //DBL_EPSILON

#include "filter.h"

#define MIN_WIDTH	32
#define MIN_HEIGHT	32
#define MAX_WIDTH	1920
#define MAX_HEIGHT	1080
#define MAX_CRIP	1024
#define MAX_SUBPX	100

#define LANC_RAD 3.0

#ifndef PI
#define PI (atan(1)*4)
#endif

#define ID_CLIP_TOP    0
#define ID_CLIP_BOTTOM 1
#define ID_CLIP_LEFT   2
#define ID_CLIP_RIGHT  3
#define ID_CLIP_DT     0
#define ID_CLIP_DB     1
#define ID_CLIP_DL     2
#define ID_CLIP_DR     3

#define ID_TRACK_SWITCH  0
#define ID_TRACK_TOP     1
#define ID_TRACK_DT      2
#define ID_TRACK_BOTTOM  3
#define ID_TRACK_DB      4
#define ID_TRACK_LEFT    5
#define ID_TRACK_DL      6
#define ID_TRACK_RIGHT   7
#define ID_TRACK_DR      8
#define ID_TRACK_WIDTH   9
#define ID_TRACK_HEIGHT 10


//---------------------------------------------------------------------
//		O[oϐ
//---------------------------------------------------------------------

typedef struct {
	int   clip[4];
	int   dc[4];
} FILTER_SETTINGS;

FILTER_SETTINGS flt_stgs[2];

typedef struct {
	int    length;
	int    src;
	double clp;
	int    rst;
	double left;
	double right;
	int    width;
	int    height;
	int    tap;
	int    step;
	double factor;
	double scale;
	double support;
	int    **weight;
	int    **index;
} PARAMETER;

PARAMETER x_prm;
PARAMETER y_prm;


/*------------------------------------------------------------------
   function prototypes
 ------------------------------------------------------------------*/

static void set_clip_prms( FILTER *fp, FILTER_PROC_INFO *fpip, int former, int latter);
static void horizontal_filter( PIXEL_YC *in, PIXEL_YC *out, PARAMETER *prm );
static void vertical_filter( PIXEL_YC *in, PIXEL_YC *out, PARAMETER *prm );
static void set_lanc_prms( PARAMETER *prm );
static double lanczos(double phase);

static void setup_range(FILTER *fp, void *editp);


//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------

#define	TRACK_N	11														//	gbNo[̐
TCHAR	*track_name[] =		{"switch",  "top","",  "bottom","",  "left","",  "right","",  "width","height"};	//	gbNo[̖O
int		track_default[] =	{0,  0,0,  0,0,  0,0,  0,0,  320,240};	//	gbNo[̏l
int		track_s[] =			{0,  0,0,  0,0,  0,0,  0,0,  MIN_WIDTH,MIN_HEIGHT};	//	gbNo[̉l
int		track_e[] =			{1,  MAX_CRIP,MAX_SUBPX-1,  MAX_CRIP,MAX_SUBPX-1,  MAX_CRIP,MAX_SUBPX-1,  MAX_CRIP,MAX_SUBPX-1,  MAX_WIDTH,MAX_HEIGHT};	//	gbNo[̏l

#define CHECK_N 0

FILTER_DLL filter = {
/******
	FILTER_FLAG_EX_INFORMATION,
	0,0,						//	ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
	"Nbv ver 0.0",		//	tB^̖O
	TRACK_N,					//	gbNo[̐ (0Ȃ疼OlNULLł悢)
	track_name,					//	gbNo[̖OSւ̃|C^
	track_default,				//	gbNo[̏lSւ̃|C^
	track_s,track_e,			//	gbNo[̐l̉ (NULLȂS0`256)
	CHECK_N,					//	`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
	NULL,						//	`FbN{bNX̖OSւ̃|C^
	NULL,						//	`FbN{bNX̏lSւ̃|C^
	func_proc,					//	tB^֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_WndProc,				//	ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,NULL,					//	VXeŎg܂̂ŎgpȂł
	NULL,						//  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	NULL,						//  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	"Nbv ver 0.0 by mer",
								//  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
	NULL,						//	Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
******/
	
	FILTER_FLAG_EX_INFORMATION|FILTER_FLAG_WINDOW_THICKFRAME|FILTER_FLAG_WINDOW_SIZE,
	320,320,
	"Nbv",
	TRACK_N,
	track_name,					//	gbNo[̖OSւ̃|C^
	track_default,				//	gbNo[̏lSւ̃|C^
	track_s,track_e,			//	gbNo[̐l̉ (NULLȂS0`256)
	CHECK_N,					//	`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
	NULL,						//	`FbN{bNX̖OSւ̃|C^
	NULL,						//	`FbN{bNX̏lSւ̃|C^
	func_proc,					//	tB^֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_update,				//	ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	func_WndProc,						//	ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	gbNo[̐ݒlSւ̃|C^ (AviUtlŐݒ肳܂)
	NULL,						//	`FbN{bNX̐ݒlSւ̃|C^ (AviUtlŐݒ肳܂)
	NULL,						//	gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	NULL,						//	gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	"Nbv ver 0.0 by mer",
								//	tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
	NULL,						//	Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
								//	s	 	: Z[u擪t[
								//	e 		: Z[uŏIt[
								//  ߂l	: ȂTRUE
	NULL,						//	Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	O֐e[uւ̃|C^ (AviUtlŐݒ肳܂)
	NULL,						//	EBhEnh (AviUtlŐݒ肳܂)
	NULL,						//	DLL̃CX^Xnh (AviUtlŐݒ肳܂)
	NULL,						//	gf[^̏lf[^̈ւ̃|C^ (NULLȂ珉܂)
	NULL,						//	C^[[XtB^ŕۑt[߂鎞ɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
								//	saveno		: Z[u͈͂̐擪̃t[ԍ
								//	frame		: ҏWt[ԍ
								//	fps			: t[[g̕ύX̐ݒl (30,24,20,15,10)
								//	edit_flag	: ҏWtO
								//	inter		: t[̃C^[[X
								//	߂l		: TRUEԂƕۑt[AFALSEԂƊԈt[ɂȂ܂B
	NULL,						//	vWFNgt@Cf[^ǂݍ񂾎ɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
								//	vWFNgt@Cɕۑf[^ꍇ͌Ă΂܂
								//	data 	: vWFNgǂݍ񂾃f[^ւ̃|C^
								//	size 	: vWFNgǂݍ񂾃f[^̃oCg
								//  ߂l	: ȂTRUE
	NULL,						//	vWFNgt@CZ[uĂ鎞ɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
								//	vWFNgɃtB^̃f[^ۑ܂
								//	data 	: vWFNgɏރf[^i[obt@ւ̃|C^ (NULL̏ꍇ̓f[^̃oCĝݕԂ)
								//	size 	: vWFNgɏރf[^̃oCgԂ|C^
								//  ߂l	: ۑf[^ȂTRUE
	NULL,						//	CEBhẼ^Cgo[\鎞ɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
								//	^Cgo[̕ύXł܂ (ҏWAo͎͌Ă΂܂)
								//	frame		: ҏWt[ԍ
								//	title 		: \^Cgo[̕
								//	max_title 	: titlẽobt@TCY
								//  ߂l	: ȂTRUE
	NULL,						//	PluginsfBNg̃TufBNgDLL鎞̂݁ATufBNg܂B
	NULL,						//	gpɗ\񂳂Ă܂BNULLɂĂB

};


//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------

EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}


/*------------------------------------------------------------------
   tB^֐
 ------------------------------------------------------------------*/
 
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
//
//	fp->track[n]			: gbNo[̐l
//	fp->check[n]			: `FbN{bNX̐l
//	fpip->w 				: ۂ̉摜̉
//	fpip->h 				: ۂ̉摜̏c
//	fpip->max_w				: 摜̈̉
//	fpip->max_h				: 摜̈̏c
//	fpip->ycp_edit			: 摜̈ւ̃|C^
//	fpip->ycp_temp			: e|̈ւ̃|C^
//	fpip->ycp_edit[n].y		: f(Px    )f[^ (     0 ` 4096 )
//	fpip->ycp_edit[n].cb	: f(F())f[^ ( -2048 ` 2048 )
//	fpip->ycp_edit[n].cr	: f(F())f[^ ( -2048 ` 2048 )
//
//  ff[^͔͈͊OɏoĂ邱Ƃ܂B
//  ܂͈͓Ɏ߂ȂĂ܂܂B
//
//	摜TCYςƂ fpip->w  fpip->h ς܂B
//
//	e|̈ɏ摜i[Ƃ
//	fpip->ycp_edit  fpip->ycp_temp ւ܂B
//
	PIXEL_YC *swap;
	
	int frame_now = fpip->frame;
	int frame_from, frame_to;
	
	/* ݂̃t[ł̐؂ʂ̐ݒ */
	
	fp->exfunc->get_select_frame(fpip->editp, &frame_from, &frame_to);
	
	set_clip_prms(fp, fpip, frame_now-frame_from, frame_to-frame_now);
	
	/*  */
	
	horizontal_filter(fpip->ycp_edit, fpip->ycp_temp, &x_prm);
	
	swap = fpip->ycp_edit;
	fpip->ycp_edit = fpip->ycp_temp;
	fpip->ycp_temp = swap;
	fpip->w = fp->track[ID_TRACK_WIDTH];
	
	/* c */
	
	vertical_filter(fpip->ycp_edit, fpip->ycp_temp, &y_prm);
	
	swap = fpip->ycp_edit;
	fpip->ycp_edit = fpip->ycp_temp;
	fpip->ycp_temp = swap;
	fpip->h = fp->track[ID_TRACK_HEIGHT];
	
	return TRUE;
}


static void set_clip_prms( FILTER *fp, FILTER_PROC_INFO *fpip, int former, int latter)
{ //ݒEBhE̒lA⊮Č݂̃t[ł̃Nbvʂݒ
	double a[4], b[4], clip[4];
	double d = 1.0/MAX_SUBPX;
	int i;
	
	if(former < 0 || latter < 0){/*ǂ炩Ȃ*/
		for(i=0;i<4;i++)
			clip[i] = 0.0;
	}else if( former || latter ){/*ǂ炩0łȂȂ*/
		for(i=0;i<4;i++){
			a[i] = (flt_stgs[0].clip[i] + flt_stgs[0].dc[i] * d) * latter;
			b[i] = (flt_stgs[1].clip[i] + flt_stgs[1].dc[i] * d) * former;
			clip[i] = (a[i] + b[i]) / (former + latter);
		}
	}else{/*0Ȃ*/
		for(i=0;i<4;i++)
			clip[i] = flt_stgs[0].clip[i] + flt_stgs[0].dc[i] * d;
	}
	
	x_prm.src     = fpip->w;
	x_prm.clp     = x_prm.src - (clip[ID_CLIP_LEFT] + clip[ID_CLIP_RIGHT]);
	x_prm.rst     = fp->track[ID_TRACK_WIDTH];
	x_prm.factor  = x_prm.rst / x_prm.clp;                           //g嗦
	x_prm.scale   = (x_prm.factor < 1.0) ? x_prm.factor : 1.0; //min //src1ڐ̒
	x_prm.support = LANC_RAD / x_prm.scale;                          //src̃f[^(񔼕)
	x_prm.tap     = (int)(2 * x_prm.support) + 1;                    //src̃f[^
	
	y_prm.src     = fpip->h;
	y_prm.clp     = y_prm.src - (clip[ID_CLIP_TOP] + clip[ID_CLIP_BOTTOM]);
	y_prm.rst     = fp->track[ID_TRACK_HEIGHT];
	y_prm.factor  = y_prm.rst / y_prm.clp;
	y_prm.scale   = (y_prm.factor < 1.0) ? y_prm.factor : 1.0; //min
	y_prm.support = LANC_RAD / y_prm.scale;
	y_prm.tap     = (int)(2 * y_prm.support) + 1;
	
	x_prm.left  = clip[ID_CLIP_LEFT];
	x_prm.right = clip[ID_CLIP_RIGHT];
	y_prm.left  = clip[ID_CLIP_TOP];
	y_prm.right = clip[ID_CLIP_BOTTOM];
	
	x_prm.width  = x_prm.rst; // not x_prm.src
	x_prm.height = y_prm.src; // not y_prm.rst
	
	y_prm.width  = x_prm.rst;
	y_prm.height = y_prm.rst;
	
	x_prm.step = fpip->max_w;
	y_prm.step = fpip->max_w;
}


static void horizontal_filter( PIXEL_YC *in, PIXEL_YC *out, PARAMETER *prm )
{
	int length = prm->rst;
	int tap = prm->tap;
	int step = prm->step;
	int **weight;
	int **index;
	
	int i, j, k;
	int luma, cb, cr;
	
	weight = (int **)malloc(sizeof(int *)*length);
	index = (int **)malloc(sizeof(int *)*length);
	
	for(i=0;i<length;i++){
		weight[i] = (int *)malloc(sizeof(int)*tap);
		index[i] = (int *)malloc(sizeof(int)*tap);
	}
	
	prm->weight = weight;
	prm->index = index;
	
	set_lanc_prms(prm);
	
	for(i=0; i < prm->height; i++){ /* c[v */
		for(j=0; j < prm->width; j++){ /* [v */
			luma = 0;
			cb = 0;
			cr = 0;
			for(k=0; k < prm->tap; k++){
				luma += in[i*step+index[j][k]].y * weight[j][k];
				cb += in[i*step+index[j][k]].cb * weight[j][k];
				cr += in[i*step+index[j][k]].cr * weight[j][k];
			}
			out[i*step+j].y = (short)((luma + (1 << 15)) >> 16);
			out[i*step+j].cb = (short)((cb + (1 << 15)) >> 16);
			out[i*step+j].cr = (short)((cr + (1 << 15)) >> 16);
		}
	}
	
	for(i=0;i<length;i++){
		free(weight[i]);
		free(index[i]);
	}
	free(weight);
	free(index);
	
}


static void vertical_filter( PIXEL_YC *in, PIXEL_YC *out, PARAMETER *prm )
{
	int length = prm->rst;
	int tap = prm->tap;
	int step = prm->step;
	int **weight;
	int **index;
	
	int i, j, k;
	int luma, cb, cr;
	
	weight = (int **)malloc(sizeof(int *)*length);
	index = (int **)malloc(sizeof(int *)*length);
	
	for(i=0;i<length;i++){
		weight[i] = (int *)malloc(sizeof(int)*tap);
		index[i] = (int *)malloc(sizeof(int)*tap);
	}
	
	prm->weight = weight;
	prm->index  = index;
	
	set_lanc_prms(prm);
	
	for(i=0; i < prm->height; i++){ /* c[v */
		for(j=0; j < prm->width; j++){ /* [v */
			luma = 0;
			cb = 0;
			cr = 0;
			for(k=0; k < prm->tap; k++){
				luma += in[index[i][k]*step+j].y * weight[i][k];
				cb += in[index[i][k]*step+j].cb * weight[i][k];
				cr += in[index[i][k]*step+j].cr * weight[i][k];
			}
			out[i*step+j].y = (short)((luma + (1 << 15)) >> 16);
			out[i*step+j].cb = (short)((cb + (1 << 15)) >> 16);
			out[i*step+j].cr = (short)((cr + (1 << 15)) >> 16);
		}
	}
	
	for(i=0;i<length;i++){
		free(weight[i]);
		free(index[i]);
	}
	free(weight);
	free(index);
	
}


static void set_lanc_prms( PARAMETER *prm )
{
	int src = prm->src;
	int tap = prm->tap;
	double left = prm->left;
	double factor = prm->factor;   //g嗦
	double scale = prm->scale;     //src1ڐ̒
	double support = prm->support; //src̃f[^(񔼕)
	int **weight = prm->weight;
	int **index = prm->index;

	int pos;
	double center, start;
	double sum;
	double distance;
	
	double *work;
	
	int x, n;
	
	work = (double *)malloc(sizeof(double)*tap);
	
	for(x=0; x<prm->rst; ++x){
		center = (x + 0.5) / factor + left;
		start = center-support+0.5;
		pos = (int)((start > 0.0) ? start : 0.0);
		sum = 0.0;
		distance = pos - center +0.5;
		for(n=0; n<tap; ++n){
			index[x][n] = pos;
			work[n] = (pos < src) ? lanczos(distance) : 0.0;
			sum += work[n];
			++pos;
			++distance;
		}
		for(n=0; n<tap; ++n){
			weight[x][n] = (int)((work[n] / sum) * (1<<16));
		}
	}
	
	free(work);
	
}


static double lanczos(double phase)
{
	double ret;
	
	if(fabs(phase) < DBL_EPSILON){
		return 1.0;
	}
	
	if(fabs(phase) >= LANC_RAD){
		return 0.0;
	}
	
	phase *= PI;
	ret = sin(phase) * sin(phase / LANC_RAD) / (phase * phase / LANC_RAD);
	
	return ret;
}


//---------------------------------------------------------------------
//		JnɌĂ΂֐
//---------------------------------------------------------------------

/*****
BOOL func_init(FILTER *fp)
{
	void *editp;
	
	setup_range(fp, editp);
	
	return TRUE;
	
}
*****/


//---------------------------------------------------------------------
//		ݒ肪ύXꂽƂɌĂ΂֐
//---------------------------------------------------------------------

BOOL func_update( FILTER *fp,int status )
{
	int track_n = status - FILTER_UPDATE_STATUS_TRACK;
	
	switch(track_n){
		case ID_TRACK_SWITCH:
			fp->track[ID_TRACK_TOP]    = flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_TOP];
			fp->track[ID_TRACK_BOTTOM] = flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_BOTTOM];
			fp->track[ID_TRACK_LEFT]   = flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_LEFT];
			fp->track[ID_TRACK_RIGHT]  = flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_RIGHT];
			fp->track[ID_TRACK_DT]     = flt_stgs[ fp->track[ID_TRACK_SWITCH] ].dc[ID_CLIP_DT];
			fp->track[ID_TRACK_DB]     = flt_stgs[ fp->track[ID_TRACK_SWITCH] ].dc[ID_CLIP_DB];
			fp->track[ID_TRACK_DL]     = flt_stgs[ fp->track[ID_TRACK_SWITCH] ].dc[ID_CLIP_DL];
			fp->track[ID_TRACK_DR]     = flt_stgs[ fp->track[ID_TRACK_SWITCH] ].dc[ID_CLIP_DR];
			fp->exfunc->filter_window_update(fp);
			return TRUE;
		case ID_TRACK_TOP:
			if(fp->track[ID_TRACK_TOP]+fp->track[ID_TRACK_BOTTOM] > track_e[ID_TRACK_TOP]){
				flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_TOP] = track_e[ID_TRACK_TOP]-fp->track[ID_TRACK_BOTTOM];
				fp->track[ID_TRACK_TOP] = track_e[ID_TRACK_TOP]-fp->track[ID_TRACK_BOTTOM];
				fp->exfunc->filter_window_update(fp);
			}else{
				flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_TOP] = fp->track[ID_TRACK_TOP];
			}
			return TRUE;
		case ID_TRACK_BOTTOM:
			if(fp->track[ID_TRACK_BOTTOM]+fp->track[ID_TRACK_TOP] > track_e[ID_TRACK_BOTTOM]){
				flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_BOTTOM] = track_e[ID_TRACK_BOTTOM]-fp->track[ID_TRACK_TOP];
				fp->track[ID_TRACK_BOTTOM] = track_e[ID_TRACK_BOTTOM]-fp->track[ID_TRACK_TOP];
				fp->exfunc->filter_window_update(fp);
			}else{
				flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_BOTTOM] = fp->track[ID_TRACK_BOTTOM];
			}
			return TRUE;
		case ID_TRACK_LEFT:
			if(fp->track[ID_TRACK_LEFT]+fp->track[ID_TRACK_RIGHT] > track_e[ID_TRACK_LEFT]){
				flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_LEFT] = track_e[ID_TRACK_LEFT]-fp->track[ID_TRACK_RIGHT];
				fp->track[ID_TRACK_LEFT] = track_e[ID_TRACK_LEFT]-fp->track[ID_TRACK_RIGHT];
				fp->exfunc->filter_window_update(fp);
			}else{
				flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_LEFT] = fp->track[ID_TRACK_LEFT];
			}
			return TRUE;
		case ID_TRACK_RIGHT:
			if(fp->track[ID_TRACK_RIGHT]+fp->track[ID_TRACK_LEFT] > track_e[ID_TRACK_RIGHT]){
				flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_RIGHT] = track_e[ID_TRACK_RIGHT]-fp->track[ID_TRACK_LEFT];
				fp->track[ID_TRACK_RIGHT] = track_e[ID_TRACK_RIGHT]-fp->track[ID_TRACK_LEFT];
				fp->exfunc->filter_window_update(fp);
			}else{
				flt_stgs[ fp->track[ID_TRACK_SWITCH] ].clip[ID_CLIP_RIGHT] = fp->track[ID_TRACK_RIGHT];
			}
			return TRUE;
		case ID_TRACK_DT:
			flt_stgs[ fp->track[ID_TRACK_SWITCH] ].dc[ID_CLIP_DT] = fp->track[ID_TRACK_DT];
			return TRUE;
		case ID_TRACK_DB:
			flt_stgs[ fp->track[ID_TRACK_SWITCH] ].dc[ID_CLIP_DB] = fp->track[ID_TRACK_DB];
			return TRUE;
		case ID_TRACK_DL:
			flt_stgs[ fp->track[ID_TRACK_SWITCH] ].dc[ID_CLIP_DL] = fp->track[ID_TRACK_DL];
			return TRUE;
		case ID_TRACK_DR:
			flt_stgs[ fp->track[ID_TRACK_SWITCH] ].dc[ID_CLIP_DR] = fp->track[ID_TRACK_DR];
			return TRUE;
		case ID_TRACK_WIDTH:
			return TRUE;
		case ID_TRACK_HEIGHT:
			return TRUE;
			
	}
	
	return FALSE;
	
}


//---------------------------------------------------------------------
//		ݒEBhEɃEBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------

BOOL func_WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
	switch(message){
	case WM_FILTER_INIT:
		setup_range(fp, editp);
		return TRUE;
	}
	
	return FALSE;
	
}

static void setup_range(FILTER *fp, void *editp)
{
	SYS_INFO si;
/*****
	int width, height;
	
	if(fp->exfunc->get_frame_size(editp, &width, &height)){
		fp->exfunc->get_frame_size(editp, &width, &height);
		
		track_e[ID_TRACK_TOP]    = height - 3;
		track_e[ID_TRACK_BOTTOM] = height - 3;
		track_e[ID_TRACK_LEFT]   = width - 3;
		track_e[ID_TRACK_RIGHT]  = width - 3;
		
		fp->track[ID_TRACK_WIDTH] = width;
		fp->track[ID_TRACK_HEIGHT] = height;
		
		fp->exfunc->filter_window_update(fp);
	}
*****/
	
	if(fp->exfunc->get_sys_info){
		fp->exfunc->get_sys_info(editp, &si);
		
		track_e[ID_TRACK_TOP]    = si.max_h - 3;
		track_e[ID_TRACK_BOTTOM] = si.max_h - 3;
		track_e[ID_TRACK_LEFT]   = si.max_w - 3;
		track_e[ID_TRACK_RIGHT]  = si.max_w - 3;
		
		track_s[ID_TRACK_WIDTH]  = si.min_w;
		track_s[ID_TRACK_HEIGHT] = si.min_h;
		
		track_e[ID_TRACK_WIDTH]  = si.max_w;
		track_e[ID_TRACK_HEIGHT] = si.max_h;
		
		fp->exfunc->filter_window_update(fp);
	}
}
